var httpRoot = "https://m.memberz.fr/cartatoo";
var folder = httpRoot + "/applications/on the road/cartatoo";
var pathRoot = "cartatoo.fr.memberz.m";
var pictureSource;   // picture source
var destinationType; // sets the format of returned value
var isPayPalActive = false;

/* -----------------------------------------
Initialisation du device
------------------------------------------- */
var app = {
	initialize: function(){
		this.bindEvents();
	},
	// Bind any events that are required on startup. Common events are:
	// 'load', 'deviceready', 'offline', and 'online'.
	bindEvents: function(){
		document.addEventListener('deviceready', this.onDeviceReady, false);
	},
	// The scope of 'this' is the event. In order to call the 'receivedEvent'
	// function, we must explicitly call 'app.receivedEvent(...);'
	onDeviceReady: function(){
		app.receivedEvent('deviceready');
	},
	// Update DOM on a Received Event
	receivedEvent: function(id){
		setTimeout(function(){
			// On tente de récupérer l'utilisateur connecté
			checkUserConnection();

			// Initialisation de la librairie PayPalMobile
			if(myApp.device.android || myApp.device.ios){
				app.initPaymentUI();
			}
		}, 2000);

		setTimeout(function(){
			// On paramètre des variables "CAMERA"
			pictureSource = navigator.camera.PictureSourceType;
			destinationType = navigator.camera.DestinationType;

			// On affiche le numéro de version de l'application
			$(".login-screen .appliVersion .version span").html(AppVersion.version);
		}, 3000);
	},
	initPaymentUI: function(){
		// On récupère la conf PayPal
		$.ajax({
			url: folder + "/resources/paypal.xml",
			dataType: "xml"
		})
		.done(function(data){
			// Si le paiement PayPal est actif
			if(typeof $(data).find("paypal").attr("active") !== "undefined" && $(data).find("paypal").attr("active") == "1"){
				isPayPalActive = true;
				
				var clientIDs = {
					"PayPalEnvironmentProduction": $(data).find("paypal").find("clientIDs").attr("PayPalEnvironmentProduction"),
					"PayPalEnvironmentSandbox": $(data).find("paypal").find("clientIDs").attr("PayPalEnvironmentSandbox")
				};

				var configuration = function(){
					var params = {};

					// On parcourt les paramètres
					$.each($(data).find("paypal").find("config")[0].childNodes, function(i, param){
						if(param.nodeName != "#text"){
							params[param.nodeName] = $(param).text();
						}
					});

					var config = new PayPalConfiguration(params);
					return config;
				};

				var onPayPalMobileInit = function(){
					// use PayPalEnvironmentNoNetwork mode to get look and feel of the flow
					// PayPalMobile.prepareToRender("PayPalEnvironmentNoNetwork", configuration());
					PayPalMobile.prepareToRender("PayPalEnvironmentSandbox", configuration());
				};

				PayPalMobile.init(clientIDs, onPayPalMobileInit());
			}
		})
		.fail(function(){
			console.log("Erreur récupération paypal.xml");
		});
	}
};

var myApp = new Framework7({
	animatePages: false,
	animateNavBackIcon:true,
	precompileTemplates: true,
	template7Pages: true,
	template7Data: {
		'page:wallet_recharge': {
			months: [{value: "01", name: "Janvier"}, {value: "02", name: "Février"}, {value: "03", name: "Mars"}, {value: "04", name: "Avril"}, {value: "05", name: "Mai"}, {value: "06", name: "Juin"}, {value: "07", name: "Juillet"}, {value: "08", name: "Août"}, {value: "09", name: "Septembre"}, {value: "10", name: "Octobre"}, {value: "11", name: "Novembre"}, {value: "12", name: "Décembre"}]
		}
	},
	uniqueHistory: true,
	cache: false,
	preloadPreviousPage: false,
	// swipeBackPage: false,
	notificationHold: 3000,
	notificationCloseOnClick: true,
	scrollTopOnNavbarClick: true,
	scrollTopOnStatusbarClick: true,
	smartSelectBackText: '',
	smartSelectPopupCloseText: '',
	imagesLazyLoadThreshold: 50,
	modalButtonCancel: 'Annuler',
	toolbarCloseText: 'OK',
	onPageInit: function(pageName, page){
		// On réinitialise la liste des postevents du dernier profil visité
		if(page.name != "postevent" && typeof profilePosts !== "undefined"){profilePosts = undefined};

		// Gestion de l'affichage de la navbar - Si on est pas sur la page "Profil", on l'affiche
		if(page.container.className.indexOf("page-on-right") != -1 && page.name != "profile" && $(".navbar").hasClass("transparent")){$(".navbar").removeClass("transparent");}
		
		setTimeout(function(){
			// On vérouille l'application en mode portrait
			if(typeof screen.lockOrientation !== "undefined"){screen.lockOrientation('portrait');}
		}, 250);

		// Désactivation du listener sur le changement d'orientation du périphérique
		$(window).off("orientationchange");

		// Si le currentUser n'a pas accepté la Charte d'utilisation du réseau social, on désactive la publication d'un postevent
		if(typeof currentUser !== "undefined" && currentUser && !currentUser.socialAccess && !localStorage.getItem("socialAccess")){$(".navbar-on-right #editPostBtn").attr("disabled", "disabled");}
	}
});
	
// Export selectors engine
var $$ = Dom7;

var mainView = myApp.addView('.view-main', {
	// Enable dynamic Navbar
	dynamicNavbar: true
});

app.initialize();