window.Medias = {

	embed: function (url, element){
		return Medias.render(Medias.parseURL(url), element);
	},
	
	preview: function (){
		return "1234";
	},
	
    richify: function (){
		return "1234";
	},
	
	/**/
    display: function (template, data, element) {
        if(template && element) { 
			$(element).html(Medias.generate(template.markup, data));
            $(element).addClass('loaded');
		}
    },
	
    findDomain: function (URL) {
        var domainName, domainNameIndex, domainNames;
        domainNames = URL.hostname.split('.');

        for (domainNameIndex in domainNames) {
            domainName = domainNames[domainNameIndex];
			if (Medias.domains[domainName] !== undefined) {
                break;
            }
        }

		return Medias.domains[domainName];
    },

    findExtension: function (URL) {
        var extensionName, extensionNames;

        extensionNames = URL.pathname.split('.');
        extensionName = extensionNames[extensionNames.length-1];

        return Medias.extensions[extensionName];
    },
	
    generate: function (template, data) {
        var field, output;
		
		output = template;
		
		if(output) {
			for (field in data) {
				output = output.replace(new RegExp("{{" + field + "}}", "g"), data[field]);
			}
		}
		
		return output;
    },
	
    loadScript: function (element, src) {
		if(element && src) {
			var script = $("<script></script>");
			script.attr('type', 'text/javascript');
			script.attr('src', src);
			$(element).append(script);
		}
    },
	
    parseURL: function (URLString) {
        var cleanPathchunks, parser, pathchunks, pathchunkIndex, query, queryIndex, queryPairs, queryPair, queryString, search;

        parser = document.createElement('a');
        parser.href = URLString;

        query = {};
        cleanPathchunks = [];

        if (parser.search) {
            search = parser.search;
        } else {
            var splitURL = URLString.replace(/#.+/, "").split('?');
            if (splitURL.length == 2) {
                search = "?" + splitURL[1];
            }else{
                search = "";
            }
        }

        if (search && search[0] === "?") {
            queryString = search.slice(1, search.length);
            queryPairs = queryString.split("&");
            for (queryIndex = 0; queryIndex < queryPairs.length; queryIndex += 1) {
                queryPair = queryPairs[queryIndex].split("=");
                query[queryPair[0]] = queryPair[1];
            }
        }

        if (parser.pathname !== "") {
            pathchunks = parser.pathname.split("/");
            for (pathchunkIndex = 0; pathchunkIndex < pathchunks.length; pathchunkIndex += 1) {
                if (pathchunks[pathchunkIndex]) {
                    cleanPathchunks.push(pathchunks[pathchunkIndex]);
                }
            }
        }

        return {
            url: URLString,               // => "http://example.com:3000/pathname/?search=test#hash"
            protocol: parser.protocol,    // => "http:"
            hostname: parser.hostname,    // => "example.com"
            port: parser.port,            // => "3000"
            pathname: parser.pathname,    // => "/pathname/"
            pathchunks: cleanPathchunks,  // => ["pathname"]
            querystring: queryString,     // => "search=test"
            query: query,                 // => {search: "test"}
            hash: parser.hash,            // => "#hash"
            host: parser.host             // => "example.com:3000"
        };
    },
	
	render: function (URL, element) {
        var src, definition, domainName, extensionName, field, scriptIndex;

        domain = Medias.findDomain(URL);
		extension = Medias.findExtension(URL);

        if (domain || extension) {
			definition = (domain || extension)(URL);
			
			if(definition) {
				if (definition.template && definition.template.scripts) {
					for (scriptIndex = 0; scriptIndex < definition.template.scripts.length; scriptIndex += 1) {
						src = definition.template.scripts[scriptIndex];
						Medias.loadScript(element, Medias.generate(src, definition.data));
					}
				}

				Medias.display(definition.template, definition.data, element);
			
				return true;
			
			} else {
				return false;
			}
		
		} else {
			return false;
		}

    },
	
	/**/
    domains : {
        // Youtube.com Video Structure
        youtube: function (URL) {
            return {
                template : {
					markup: '<iframe width="500" height="280" src="{{embedURL}}" frameborder="0" allowfullscreen></iframe>'
				},
				data: {
                    embedURL: 'https://www.youtube.com/embed/' + URL.query.v
                }
            };
        },

        // Youtu.be Video Structure
        youtu: function (URL) {
            return {
                template : {
					markup: '<iframe width="500" height="280" src="{{embedURL}}" frameborder="0" allowfullscreen></iframe>'
				},
                data: {
                    embedURL: 'https://www.youtube.com/embed/' + URL.pathname.slice(1, URL.pathname.length)
                }
            };
        },

        // Vimeo.com Video Structure
        vimeo: function (URL) {
            return {
                template : {
					markup: '<iframe src="{{embedURL}}" width="420" height="345" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen></iframe>'
				},
                data: {
					embedURL: 'https://player.vimeo.com/video/' + URL.pathchunks[URL.pathchunks.length-1]
                }
            };
        },

        // Dailymotion.com Video Structure
        dailymotion: function (URL) {
            return {
                template : {
					markup: '<iframe frameborder="0" width="420" height="345" src="{{embedURL}}" allowfullscreen></iframe>'
				},
                data: {
                   embedURL: 'https://www.dailymotion.com/embed/video/' + URL.pathchunks[1]
                }
            };
        },

		 // Dai.ly Video Structure
        dai: function (URL) {
            return {
                template : {
					markup: '<iframe frameborder="0" width="420" height="345" src="{{embedURL}}" allowfullscreen></iframe>'
				},
                data: {
                   embedURL: 'https://www.dailymotion.com/embed/video/' + URL.pathchunks[1]
                }
            };
        },

        // Vine.com Video Structure
        vine: function (URL) {
            return {
                template : {
					markup: '<iframe class="vine-embed" src="{{embedURL}}" width="420" height="345" frameborder="0"></iframe><script async src="//platform.vine.co/static/scripts/embed.js" charset="utf-8"></script>'
				},
                data: {
                   embedURL: 'https://vine.co/v/' + URL.pathchunks[1] + '/embed/simple'
                }
            };
        },

        // Ted.com Video Structure
        ted: function (URL) {
            return {
                template : {
					markup: '<iframe src="{{embedURL}}" width="420" height="345" frameborder="0" scrolling="no" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>'
				},
                data: {
                   embedURL: 'https://embed.ted.com/talks/' + URL.pathchunks[1] + '.html'
                }
            };
        },

        // Imgur Image Structure
        imgur: function (URL) {
            return {
                template : {
					markup: '<img src="{{embedURL}}" />'
				},
                data: {
                    embedURL: 'https://i.imgur.com/' + URL.pathchunks[0] + '.gif'
                }
            };
        },

        // Twitter Structure
        twitter: function (URL) {
            /* var markup = (URL.pathchunks.length === 1 ? '<a class="twitter-timeline" href="{{embedURL}}"></a>' : '<blockquote class="twitter-tweet" lang="en"><p> <a href="{{embedURL}}"></a></blockquote>');
			
			return {
                template : {
					markup: markup,
					scripts: ['https://platform.twitter.com/widgets.js']
				},
                data: {
                    embedURL: URL.url
                }
            }; */

			return {
                template : {
					markup: '<iframe border="0" frameborder="0" width="420" height="345" src="{{embedURL}}"></iframe>'
				},
                data: {
                   embedURL: 'https://twitframe.com/show?url=' + URL.url
                }
            };
        },

        // Soundcloud Structure
        soundcloud: function (URL) {
            return {
                template : {
					markup: '<iframe width="100%" height="166" scrolling="no" frameborder="no" src="https://w.soundcloud.com/player/?url={{embedURL}}"></iframe>'
				},
                data: {
                    embedURL: URL.url
                }
            };
        },

        // Spotify Structure
        spotify: function (URL) {
            return {
                template : {
					markup: '<iframe src="https://embed.spotify.com/?uri=spotify:track:{{embedID}}" width="300" height="380" frameborder="0" allowtransparency="true"></iframe>'
				},
                data: {
                    embedID: URL.pathchunks[1]
                }
            };
        },

        // Twitch Structure
        twitch: function (URL) {
            return {
                template : {
					markup: '<object type="application/x-shockwave-flash" height="378" width="620" id="live_embed_player_flash" data="http://www.twitch.tv/widgets/live_embed_player.swf?channel={{channel}}" bgcolor="#000000"><param name="allowFullScreen" value="true" /><param name="allowScriptAccess" value="always" /><param name="allowNetworking" value="all" /><param name="movie" value="http://www.twitch.tv/widgets/live_embed_player.swf" /><param name="flashvars" value="hostname=www.twitch.tv&channel={{channel}}&auto_play=true&start_volume=25" /></object>'
				},
                data: {
                    channel: URL.pathchunks[0]
                }
            };
        }
    },
	
    extensions : {
        // Image Structure
        "image": function (URL) {
            return {
                template : {
					markup: '<img src="{{embedURL}}" />'
				},
                data: {
                    embedURL: URL.url
                }
            };
        },

        // HTML5 Video Structure
        "video": function (URL) {
            return {
                template : {
					markup: '<video src="{{embedURL}}" controls="true" autoplay loop></video>'
				},
                data: {
                    embedURL: URL.url
                }
            };
        },

        // HTML5 Video Structure
        "audio": function (URL) {
            return {
                template : {
					markup: '<audio src="{{embedURL}}" controls="true"></audio>'
				},
                data: {
                    embedURL: URL.url
                }
            };
        }
    }
	
}

window.Medias.extensions.jpg = window.Medias.extensions.image;
window.Medias.extensions.jpeg = window.Medias.extensions.image;
window.Medias.extensions.png = window.Medias.extensions.image;
window.Medias.extensions.gif = window.Medias.extensions.image;
window.Medias.extensions.bmp = window.Medias.extensions.image;

window.Medias.extensions.mp4 = window.Medias.extensions.video;
window.Medias.extensions.ogv = window.Medias.extensions.video;
window.Medias.extensions.webm = window.Medias.extensions.video;

window.Medias.extensions.ogg = window.Medias.extensions.audio;
window.Medias.extensions.mp3 = window.Medias.extensions.audio;